CLISP(1)                                                              CLISP(1)



[1mNAME[0m
       clisp - ANSI Common Lisp compiler, interpreter and debugger.



[1mSYNOPSIS[0m
       [1mclisp  [22m[  [1m-h [22m| [1m--help [22m] [ [1m--version [22m] [ [1m--license [22m] [ [1m-B [4m[22mlisplibdir[24m ] [
       [1m-K [4m[22mlinking-set[24m ] [ [1m-M [4m[22mmemfile[24m ] [ [1m-m [4m[22mmemsize[24m ] [ [1m-L  [4m[22mlanguage[24m  ]  [  [1m-N[0m
       [4mlocaledir[24m ] [ [1m-E[4m[22mdomain[24m [4mencoding[24m ] [ [1m-q [22m| [1m--quiet [22m| [1m--silent [22m] [ [1m-inter-[0m
       [1mactive-debug [22m] [ [1m-repl [22m] [ [1m-w [22m] [ [1m-I [22m] [ [1m-ansi [22m] [ [1m-traditional [22m] [  [1m-p[0m
       [4mpackagename[24m ] [ [1m-C [22m] [ [1m-v [22m| [1m-verbose [22m| [1m--verbose [22m] [ [1m-norc [22m] [ [1m-i [4m[22minit-[0m
       [4mfile[24m ...  ] [ [1m-c [22m[ [1m-l [22m] [4mlispfile[24m [ [1m-o [4m[22moutputfile[24m ] ...  ] [ [1m-x  [4m[22mexpres-[0m
       [4msions[24m ] [ [4mlispfile[24m [ [4margument[24m ] ]



[1mDESCRIPTION[0m
       Invokes  the  common  lisp  interpreter  and compiler.  Invoked without
       arguments, executes a read-eval-print loop, in which expressions are in
       turn  read  from standard input, evaluated by the lisp interpreter, and
       their results output to standard output.  Invoked with [1m-c[22m,  the  speci-
       fied  lisp  files  are compiled to a bytecode that can be executed more
       efficiently.



[1mOPTIONS[0m
       [1m-h[22m, [1m--help[0m
              Displays a help message on how to use [1mclisp[22m.


       [1m--version[0m
              Displays the [1mclisp [22mversion number, as given by the function call
              [4m(lisp-implementation-version)[24m.


       [1m--license[0m
              Displays a summary of the licensing information, the GNU GPL.


       [1m-B [4m[22mlisplibdir[0m
              Specifies the installation directory. This is the directory con-
              taining the  linking  sets  and  other  data  files.   Directory
              lisplibdir  can  be  changed  at run-time using the symbol-macro
              [1m*lib-directory*[0m


       [1m-K [4m[22mlinking-set[0m
              Specifies the linking set to be run.  This is a directory (rela-
              tive to [1mlisplibdir [22m) containing at least a main executable (run-
              time) and an initial memory image.  Possible  values  are  [1mbase[22m,
              [1mfull[22m.  The default is [1mbase[22m.


       [1m-M [4m[22mmemfile[0m
              Specifies  the initial memory image.  This must be a memory dump
              produced by the [4msaveinitmem[24m function by this [1mclisp [22mruntime.


       [1m-m [4m[22mmemsize[0m
              Sets the amount of memory [1mclisp [22mtries to grab on  startup.   The
              amount  may  be  given  as [4mnnnnnnn[24m (measured in bytes), [4mnnnn[24m[1mK [22mor
              [4mnnnn[24m[1mKB [22m(measured  in  kilobytes)  or  [4mn[24m[1mM  [22mor  [4mn[24m[1mMB  [22m(measured  in
              megabytes).   Default  is  2  megabytes.   The  argument is con-
              strained above 100 KB.  -- This version of [1mclisp [22mis  not  likely
              to actually use the entire [4mmemsize[24m since garbage collection will
              periodically reduce the amount of used memory.  It is  therefore
              common  to specify 10 MB even if only 2 MB are going to be used.




       [1m-L [4m[22mlanguage[0m
              Specifies the language [1mclisp [22muses to communicate with the  user.
              This  may  be  [1menglish[22m.  The language may be changed at run-time
              using the symbol macro [1m*current-language*.[0m


       [1m-N [4m[22mlocaledir[0m
              Specifies the base directory of locale files.  [1mclisp [22mwill search
              its message catalogs in [4mlocaledir[24m/[4mlanguage[24m/LC_MESSAGES/clisp.mo.
              The localedir may be changed at run-time using the symbol  macro
              [1m*current-language*.[0m


       [1m-E[4m[22mdomain[24m [4mencoding[0m
              Specifies  the  encoding used for a given domain, overriding the
              default which  depends  on  the  environment  variables  [1mLC_ALL[22m,
              [1mLC_CTYPE[22m,  [1mLANG[22m.   [4mdomain[24m  can be [1mfile[22m, affecting [1m*default-file-[0m
              [1mencoding*[22m, or [1mpathname[22m, affecting [1m*pathname-encoding*[22m, or [1mtermi-[0m
              [1mnal[22m,  affecting [1m*terminal-encoding*[22m, or [1mforeign[22m, affecting [1m*for-[0m
              [1meign-encoding*[22m, or [1mmisc[22m, affecting [1m*misc-encoding*[22m.   or  [4mblank,[0m
              affecting  all  of  the above.  Note that these values cannot be
              saved in a memory image.  You have to use the init file or init-
              function to set them on startup.


       [1m-q[22m, [1m--quiet[22m, [1m--silent[0m
              Quiet:  [1mclisp [22mdisplays no banner at startup and no good-bye mes-
              sage when quitting.


       [1m-interactive-debug[0m
              Override the batch mode imposed by  [1m-c[22m,  [1m-x[22m,  and  [1mlispfile  [22mand
              allow interactive handling of [4mASSERT[24m and friends.


       [1m-repl  [22mStart  an  interactive read-eval-print loop after processing the
              [1m-c[22m, [1m-x[22m, and [1mlispfile [22moption.


       [1m-w     [22mWait for a keypress after program termination.


       [1m-I     [22mBe ILISP friendly. ILISP is an alternative  Emacs  interface  to
              Common  Lisp systems. With this option, [1mclisp [22minteracts in a way
              that ILISP can deal with.  Currently the only effect of this  is
              that unnecessary prompts are not suppressed.


       [1m-ansi  [22mANSI  CL  compliant:  comply with the ANSI CL specification even
              where CLISP has been traditionally different.  It sets the  sym-
              bol macro [4m*ansi*[24m to [1mt[22m.  See impnotes.html, section "Maximum ANSI
              CL compliance", for details.


       [1m-traditional[0m
              Traditional: reverses the residual effects of [1m-ansi [22min the saved
              image.


       [1m-p [4m[22mpackagename[0m
              At  startup  the  value of the variable [4m*package*[24m will be set to
              the package named [4mpackagename[24m.  The default is the package which
              was active when the image was saved, normally [1mCOMMON-LISP-USER[0m


       [1m-C     [22mCompile  when  load: At startup the value of the variable [4m*load-[0m
              [4mcompiling*[24m will be set to [1mt[22m.  Code being  [4mload[24med  will  then  be
              compiled on the fly.  This results in slower loading, but faster
              execution.


       [1m-v[22m, [1m-verbose[22m, [1m--verbose[0m
              Verbose loading (with [1m-i [22m) and compiling (with [1m-c [22m);  this  sets
              variables [4m*load-print*[24m  [4mand[24m  [4m*compile-print*[24m  [4mto[24m  [4mt[24m [4m.[24m  Note that
              this setting persists into the read-eval-print loop.


       [1m-norc  [22mNormally [1mclisp [22mloads a user run control  (RC)  file  on  startup
              (this  happens  after  the  [1m-C  [22moption  is processed).  The file
              loaded is [1m_clisprc.lisp [22mor [1m_clisprc.fas [22min  the  home  directory
              [4m(user-homedir-pathname)[24m,   whichever  is  newest.  This  option,
              [1m-norc, [22mprevents loading of the RC file.


       [1m-i [4m[22minitfile[24m [4m...[0m
              Specifies initialization files to be [4mload[24med  at  startup.  These
              should  be  lisp  files (source or compiled). Several [1m-i [22moptions
              can be given; all the specified files will be loaded in order.


       [1m-c [4m[22mlispfile[24m [4m...[0m
              Compiles the specified [4mlispfile[24ms to bytecode (*.fas).  The  com-
              piled  files  can  then be [4mload[24med instead of the sources to gain
              efficiency.


       [1m-o [4m[22moutputfile[0m
              Specifies the output file or directory for  the  compilation  of
              the last specified [4mlispfile[24m.


       [1m-l     [22mA  bytecode  listing (*.lis) of the files being compiled will be
              produced.  Useful only for debugging purposes. See the  documen-
              tation of [4mcompile-file[24m for details.


       [1m-x [4m[22mexpressions[0m
              Executes  a  series  of arbitrary expressions instead of a read-
              eval-print loop.  The values of the expressions will  be  output
              to  standard output.  Due to the argument processing done by the
              shell, the [4mexpressions[24m must be enclosed in  double  quotes,  and
              double quotes and backslashes must be preceded by backslashes.


       [4mlispfile[24m [[4margument[24m [4m...[24m]
              Loads and executes a [4mlispfile[24m.  There will be no read-eval-print
              loop. Before [4mlispfile[24m is loaded, the  variable  [4m*args*[24m  will  be
              bound  to  a  list  of  strings, representing the [4margument[24ms.  If
              [4mlispfile[24m is [1m-[22m, the standard input is used instead of a file.  If
              [4mlispfile[24m is the empty string  or [1m-- [22mthe rest of the arguments is
              still available in [4m*args*[24m [4m,[24m for parsing by the [1minit-function  [22mof
              the current image.  This option must be the last one. No RC file
              will be executed.





[1mREFERENCE[0m
       The language implemented mostly conforms to
              ANSI Common Lisp standard X3.226-1994
              http://www.x3.org/tc_home/j13sd4.htm
       available online as the
              Common Lisp HyperSpec
              http://www.lisp.org/HyperSpec/
              ("CLHS" for short)
       which supersedes the earlier specifications
              Guy L. Steele Jr.: Common Lisp - The Language.
              Digital Press. 2nd edition 1990, 1032 pages.
              http://www.cs.cmu.edu/afs/cs.cmu.edu/project/ai-reposi-
        tory/ai/html/cltl/cltl2.html
              ("CLtL2" for short)
       and
              Guy L. Steele Jr.: Common Lisp - The Language.
              Digital Press. 1st edition 1984, 465 pages.
              ("CLtL1" for short)



[1mUSE[0m
       [1mhelp   [22mto get some on-line help.


       [1m(apropos [4m[22mname[24m[1m)[0m
              lists the symbols relating to [4mname[24m.


       [1m(exit) [22mor [1m(quit) [22mor [1m(bye)[0m
              to quit [1mclisp[22m.





[1mFILES[0m
       main executable (runtime)


       [4mlispinit.mem[0m
              initial memory image


       [4mconfig.lisp[0m
              site-dependent configuration


       [4m*.lisp[24m lisp source


       [4m*.fas[24m  lisp code, compiled by [1mclisp[0m


       [4m*.lib[24m  lisp source library information, generated and used by the [1mclisp[0m
              compiler when compiling [1mrequire [22mforms


       [4m*.c[24m    C code, compiled from lisp source by [1mclisp [22mfor the FFI



[1mENVIRONMENT[0m
       [1mCLISP_LANGUAGE[0m
              specifies the language [1mclisp [22muses to communicate with the  user.
              The  value  may  be  [1menglish[22m,  [1mgerman[22m,  [1mfrench[22m,  [1mspanish[22m, [1mdutch[22m,
              [1mrussian [22mand defaults to [1menglish[22m.  The [1m-L [22moption can be  used  to
              override this environment variable.



       [1mLC_CTYPE[0m
              specifies  the locale which determines the character set in use.
              The value can be of the form  [4mlanguage[24m  or  [4mlanguage_country[24m  or
              [4mlanguage_country.charset[24m, where [4mlanguage[24m is a two-letter ISO 639
              language code (lower case), and [4mcountry[24m is a two-letter ISO 3166
              country code (upper case).  [4mcharset[24m is an optional character set
              specification, and needs normally not be given because the char-
              acter set can be inferred from the language and country.


       [1mLANG   [22mspecifies  the language [1mclisp [22muses to communicate with the user,
              unless it is already specified through the environment  variable
              [1mCLISP_LANGUAGE  [22mor  the [1m-L [22moption.  It also specifies the locale
              determining the character set in use, unless  already  specified
              through  the environment variable [1mLC_CTYPE[22m.  The value may begin
              with a two-letter ISO 639 language code, for example [1men[22m, [1mde[22m, [1mfr[22m.








[1mSEE ALSO[0m
       impnotes.html, [4mcmucl[24m(1), [4memacs[24m(1), [4mxemacs[24m(1).


[1mBUGS[0m
       When  you  encounter  a  bug in [1mclisp [22m, please report it to the mailing
       list  (see  [4mhttp://lists.sf.net/lists/listinfo/clisp-list[24m  )   or   the
       SourceForge                bug               tracker               (see
       [4mhttp://sf.net/tracker/?func=add&group_id=1355&atid=101355[24m ).


       When submitting a bug report, please specify the following information:


       1.  What is your platform? ( [1m'uname -a' [22mon a Unix system) compiler ver-
       sion?  libc (on Linux)?


       2. Where did you get the sources?  When?  (Absolute dates are preferred
       over the relative ones)


       3.  How did you build [1mclisp [22m? (What command, options etc.)  Please do a
       clean build (remove your build directory and  build  with  [1m'./configure[0m
       [1m--build  build'  [22mor  at least do a [1m'make distclean' [22mbefore [1m'make' [22m). If
       you are reporting a crash (segmentation fault,  bus  error,  core  dump
       etc),  please  do [1m'./configure --with-debug --build build-g' [22mand report
       the backtrace.


       4. If you are using pre-built binaries, the problem is likely to be  in
       the  incompatibilities  between  the  platform  on which the binary was
       built and yours; please try compiling the sources.


       5. What is the output of [1m'clisp --version' [22m?


       6. Please supply the full output (copy and paste) of all the error mes-
       sages, as well as detailed instructions on how to reproduce them.


       Known bugs, some of which may be platform-dependent, include



       Not all extensions from CLtL2 are supported.


       No on-line documentation beyond [4mapropos[24m and [4mdescribe[24m is available.





[1mPROJECTS[0m
       Writing on-line documentation.


       Enhance the compiler so that it can inline local functions.


       Specify a portable set of window and graphics operations.



[1mAUTHORS[0m
       Bruno Haible and Michael Stoll.  See file [1mCOPYRIGHT [22mfor the list of the
       other contributors and the license.



                                  April 2003                          CLISP(1)
